﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=11
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#StartCommandReturnValue: android.app.Service.START_STICKY	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Dim PWS As PhoneWakeState
	Dim GPSNotificacion As Notification
	Dim FusedLocationProvider1 As FusedLocationProvider

End Sub

Sub Service_Create
	Log("GPS_Manual -> Service_Create")
	Log(DateTime.Date(DateTime.Now) & " " & DateTime.Time(DateTime.Now) & " GPS -> Service Create")
	'
	PWS.PartialLock
	Log("Inicia Partialock")
	'
	FusedLocationProvider1.Initialize("FusedLocationProvider1")
	'
	Update_GPS_Notification(True)
	Service.StartForeground(1, GPSNotificacion)
	Log("GPS_Manual -> END Service_Create")
End Sub

Sub Service_Start (StartingIntent As Intent)
	Log("GPS_Manual -> Service_Start")
	'
	Try
		Starter.GPS1.Initialize("GPS1")
		If Starter.GPS1.GPSEnabled = True Then
			Update_GPS_Notification(True)
			'
			Starter.GlbGPSEstado	= "A"
			'
			GPSNotificacion.Cancel(2)
		Else
			Starter.GlbGPSEstado	= "I"
			'
			Update_GPS_Notification(False)
			'
			' Service_Destroy
		End If
	Catch
		Log(LastException.Message)
	End Try
	'
	Try
		Log("GPS Service Start - Antes de Conectar")
		FusedLocationProvider1.Connect
		Log("GPS Service Start - Despues de Conectar")
		'
	Catch
		Log(LastException.Message)
	End Try
	Log("GPS_Manual -> END Service_Start")
End Sub

Public Sub StartServiceAndWait(Callback As Object)
'	CallSubDelayed(Callback, "Service_Ready")
	'
	' Al llegar aqui, ya se ejecutó:
	'	- Service_Create
	'	- Service_Start
	'
	' La duda es: Como sé que ya TERMINÖ
	'
End Sub

Sub Service_Destroy
	Log("GPS_Manual -> Service_Destroy")
	Starter.GlbGPSEnProceso	= False
	'
	PWS.ReleasePartialLock
	'
	Log("GPS_Manual -> Service_Destroy END")
End Sub

Sub FusedLocationProvider1_ConnectionFailed(ConnectionResult1 As Int)
	Log("GPS_Manual -> FusedLocationProvider1_ConnectionFailed")
	'
	'	the FusedLocationProvider ConnectionResult object contains the various CoonectionResult constants
	'
	Select ConnectionResult1
		Case FusedLocationProvider1.ConnectionResult.NETWORK_ERROR
			'	a network error has occurred, this is likely to be a recoverable error
			'	so try to connect again
			FusedLocationProvider1.Connect
		Case Else
			Log("Error en FusedLocationProvider1_ConnectionFailed")
	End Select
	Log("GPS_Manual -> FusedLocationProvider1_ConnectionFailed END")
End Sub

Sub Update_GPS_Notification (PStatus As Boolean)
	Log("GPS_Manual -> Update_GPS_Notification")
	'
	GPSNotificacion.Initialize
	If PStatus = True Then
		GPSNotificacion.Cancel(2)
		'
		GPSNotificacion.Light	= False
		GPSNotificacion.Sound	= False
		GPSNotificacion.Vibrate	= False
		GPSNotificacion.Icon	= "icon"
		GPSNotificacion.AutoCancel	= True
		GPSNotificacion.Cancel(2)
		'
		GPSNotificacion.SetInfo("GPS", "Servicio de GPS (OK)","")
		GPSNotificacion.Notify(2)
		'
	Else
		GPSNotificacion.Cancel(1)
		'
		If Starter.SysGPSNotificacion = "N" Then	' Normal
			GPSNotificacion.Insistent	= False
		Else										' Insistente
			GPSNotificacion.Insistent	= True
		End If
		'
		GPSNotificacion.Light	= True
		GPSNotificacion.Sound	= True
		GPSNotificacion.Vibrate	= True
		GPSNotificacion.Icon	= "icon"
		GPSNotificacion.AutoCancel	= True
		'
		GPSNotificacion.SetInfo("GPS Desactivado", "Debe de activar el GPS","")
		GPSNotificacion.Notify(1)
	End If
	Log("GPS_Manual -> Update_GPS_Notification END")
End Sub

Sub FusedLocationProvider1_ConnectionSuccess
	Log("GPS_Manual -> FusedLocationProvider1_ConnectionSuccess")
	'
	Dim LocationRequest1 As LocationRequest
	LocationRequest1.Initialize
	LocationRequest1.SetInterval(1000)			'	1000 milliseconds
	LocationRequest1.SetPriority(LocationRequest1.Priority.PRIORITY_HIGH_ACCURACY)
	LocationRequest1.SetSmallestDisplacement(1)	'	1 meter

	FusedLocationProvider1.RequestLocationUpdates(LocationRequest1)
	Log("GPS_Manual -> FusedLocationProvider1_ConnectionSuccess END")
End Sub

Sub FusedLocationProvider1_ConnectionSuspended(SuspendedCause1 As Int)
	Log("GPS_Manual -> FusedLocationProvider1_ConnectionSuspended")
	'
	'	the FusedLocationProvider SuspendedCause object contains the various SuspendedCause constants
	'
	Select SuspendedCause1
		Case FusedLocationProvider1.SuspendedCause.CAUSE_NETWORK_LOST
			'	TODO take action
		Case FusedLocationProvider1.SuspendedCause.CAUSE_SERVICE_DISCONNECTED
			'	TODO take action
	End Select
	'
	Log("GPS_Manual -> FusedLocationProvider1_ConnectionSuspended END")
	StopService("")
End Sub

Sub FusedLocationProvider1_LocationChanged(Location1 As Location)
	Log("GPS_Manual -> FusedLocationProvider1_LocationChanged")
	'
	Try
		'
		Starter.GlbGPSLatitud	= Location1.Latitude
		Starter.GlbGPSLongitud	= Location1.Longitude
		'
		Log("GlbGPSLatitud")
		Log(Starter.GlbGPSLatitud)
		Log("GlbGPSLongitud")
		Log(Starter.GlbGPSLongitud)
		'
		FusedLocationProvider1.Disconnect
		'
	Catch
		Log(LastException.Message)
	End Try
	'
	Log("GPS_Manual -> FusedLocationProvider1_LocationChanged END")
	CallSubDelayed2(Main, "Service_Completed", "Location has changed")
	
	StopService("")
End Sub
